<?
include_once("fileutils.inc");

function thumbnail($filename, $wid=64, $hgt=9999, $force=0, $text="")
{
  // Displays an image thumbnail, creating the thumbnail if
  // it doesn't yet exist.

  global $convert;
  $prefix = "thumb_";
  $stuff = search_parents($filename, "gfx");
  if(!$stuff)  return;

  $virt = $stuff[0];
  $real = $stuff[1];

  if(! $real)
  {
    printf("<!-- Error: Unable to find %s -->", $filename);
    return;
  }

  // calculate the filename of the thumbnail
  $real_dir = dirname($real);
  $real_file = basename($real);
  $thumb_real = $real_dir . "/" . $prefix . $real_file;

  $virt_dir = dirname($virt);
  $virt_file = basename($virt);
  $thumb_virt = $virt_dir . "/" . $prefix . $virt_file;

  // do not thumb a thumbnail
  if(substr($base_file, 0, 6) == "thumb_")
  {
    printf("<!-- Error: thumbnail() called on a thumbnail image. -->");
    return;
  }

  // Check whether to (re)create the thumbnail
  $build = 0;
  if (! file_exists($thumb_real)) { $build = 1; }
  else if ($force) { $build = 1; }
  else if (is_newer($real, $thumb_real)) { $build = 1; }

  if(! $build) // simply link to the thumbnail
  {
    printf("<a href=\"%s\">", $virt);
    image($thumb_virt, $text);
    printf("</a>");
  }
  else // create the thumbnail
  {
    $cmd = sprintf("%s -geometry %sx%s %s %s",
		   $convert, $wid, $hgt, $real, $thumb_real);
    $err = system($cmd);

    printf("<a href=\"%s\">", $virt);
    image($thumb_virt, $text);
    printf("</a>");
  }
}
?>
